// HWRECTView.cpp : implementation of the CHWRECTView class
//

#include "stdafx.h"
#include "HWRECT.h"
#include "OptionDlg.h"

#include "mmsystem.h"

#include "HWRECTDoc.h"
#include "HWRECTView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHWRECTView

IMPLEMENT_DYNCREATE(CHWRECTView, CView)

BEGIN_MESSAGE_MAP(CHWRECTView, CView)
	//{{AFX_MSG_MAP(CHWRECTView)
	ON_WM_KEYDOWN()
	ON_WM_TIMER()
	ON_COMMAND(ID_GAME_START, OnGameStart)
	ON_COMMAND(ID_GAME_END, OnGameEnd)
	ON_COMMAND(ID_GAME_OPTION, OnGameOption)
	ON_UPDATE_COMMAND_UI(ID_GAME_START, OnUpdateGameStart)
	ON_UPDATE_COMMAND_UI(ID_GAME_OPTION, OnUpdateGameOption)
	ON_UPDATE_COMMAND_UI(ID_GAME_END, OnUpdateGameEnd)
	ON_UPDATE_COMMAND_UI(ID_GAME_EXIT, OnUpdateGameExit)
	ON_UPDATE_COMMAND_UI(ID_HELP_ABOUT, OnUpdateHelpAbout)
	ON_UPDATE_COMMAND_UI(ID_HELP_HELP, OnUpdateHelpHelp)
	ON_WM_CREATE()
	ON_COMMAND(ID_HELP_HELP, OnHelpHelp)
	ON_UPDATE_COMMAND_UI(ID_OPTION_AREA1, OnUpdateOptionArea1)
	ON_UPDATE_COMMAND_UI(ID_OPTION_AREA2, OnUpdateOptionArea2)
	ON_UPDATE_COMMAND_UI(ID_OPTION_AREA3, OnUpdateOptionArea3)
	ON_UPDATE_COMMAND_UI(ID_OPTION_AREA4, OnUpdateOptionArea4)
	ON_COMMAND(ID_OPTION_AREA1, OnOptionArea1)
	ON_COMMAND(ID_OPTION_AREA2, OnOptionArea2)
	ON_COMMAND(ID_OPTION_AREA3, OnOptionArea3)
	ON_COMMAND(ID_OPTION_AREA4, OnOptionArea4)
	ON_UPDATE_COMMAND_UI(ID_OPTION_LEVEL1, OnUpdateOptionLevel1)
	ON_UPDATE_COMMAND_UI(ID_OPTION_LEVEL2, OnUpdateOptionLevel2)
	ON_UPDATE_COMMAND_UI(ID_OPTION_LEVEL3, OnUpdateOptionLevel3)
	ON_UPDATE_COMMAND_UI(ID_OPTION_LEVEL4, OnUpdateOptionLevel4)
	ON_UPDATE_COMMAND_UI(ID_OPTION_LEVEL5, OnUpdateOptionLevel5)
	ON_UPDATE_COMMAND_UI(ID_OPTION_LEVEL6, OnUpdateOptionLevel6)
	ON_COMMAND(ID_OPTION_LEVEL1, OnOptionLevel1)
	ON_COMMAND(ID_OPTION_LEVEL2, OnOptionLevel2)
	ON_COMMAND(ID_OPTION_LEVEL3, OnOptionLevel3)
	ON_COMMAND(ID_OPTION_LEVEL4, OnOptionLevel4)
	ON_COMMAND(ID_OPTION_LEVEL5, OnOptionLevel5)
	ON_COMMAND(ID_OPTION_LEVEL6, OnOptionLevel6)
	ON_UPDATE_COMMAND_UI(ID_OPTION_GRID, OnUpdateOptionGrid)
	ON_COMMAND(ID_OPTION_GRID, OnOptionGrid)
	ON_UPDATE_COMMAND_UI(ID_OPTION_MUSIC, OnUpdateOptionMusic)
	ON_COMMAND(ID_OPTION_MUSIC, OnOptionMusic)
	ON_UPDATE_COMMAND_UI(ID_GAME_PAUSH, OnUpdateGamePaush)
	ON_COMMAND(ID_GAME_PAUSH, OnGamePaush)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHWRECTView construction/destruction
/* * * * * * * * * * * * * * * * * * * * * * * * *
*
*  ƣ캯
*
*  ܣʼ
*
*  ޸ʱ䣺1999.3.22
*
* * * * * * * * * * * * * * * * * * * * * * * * */
CHWRECTView::CHWRECTView()
{
	//ȱʡΪϷͣ״̬
	m_bGamePaush = FALSE;

	//ȱʡΪű
	m_bMusic = FALSE;
	
	//ȱʡΪ
	m_bDrawGrid = TRUE;

	//ֵܷ
	m_iPerformance = 0;

	//ֵΪ12У10
	m_iRow = 12;
	m_iCol = 10;

	//ϽXY
	m_iStartX = 10;
	m_iStartY = 10;

	//ȱʡΪ3
	m_iLevel = 2;

	//ȱʡСΪm_iLarge
	m_iLarge = 30;

	//ȱʡϷǽ
	m_bGameEnd = TRUE;

	int i,j;

	//ֵ
	for (i=0;i<100;i++)
		for (j=0;j<100;j++)
			GameStatus[i][j]=0;

	//״ĽӴݣμĽӴ, ĳ״ķû4Ӵ棬-1
	for (i=0;i<74;i++)
		for (j=0;j<4;j++)
			InterFace[i][j] = -1;

	InterFace[1][0] = 3;
	
	InterFace[11][0] = 0;	InterFace[11][1] = 1;	InterFace[11][2] = 2;	InterFace[11][3] = 3;
  
	InterFace[2][0] = 1;	InterFace[2][1] = 3;
	
	InterFace[3][0] = 0;	InterFace[3][1] = 2;	InterFace[3][2] = 3;
	
	InterFace[31][0] = 2;	InterFace[31][1] = 3;
	
	InterFace[32][0] = 0;	InterFace[32][1] = 2;	InterFace[32][2] = 3;
	
	InterFace[33][0] = 0;	InterFace[33][1] = 3;
	
	InterFace[4][0] = 1;	InterFace[4][1] = 3;
	
	InterFace[41][0] = 0;	InterFace[41][1] = 2;	InterFace[41][2] = 3;
	
	InterFace[5][0] = 1;	InterFace[5][1] = 3;

	InterFace[51][0] = 0;	InterFace[51][1] = 2;	InterFace[51][2] = 3;
	
	InterFace[6][0] = 0;	InterFace[6][1] = 3;
	
	InterFace[61][0] = 1;	InterFace[61][1] = 2;	InterFace[61][2] = 3;

	InterFace[62][0] = 2;	InterFace[62][1] = 3;

	InterFace[63][0] = 0;	InterFace[63][1] = 1;	InterFace[63][2] = 3;

	InterFace[7][0] = 2;	InterFace[7][1] = 3;
	
	InterFace[71][0] = 1;	InterFace[71][1] = 2;	InterFace[71][2] = 3;

	InterFace[72][0] = 0;	InterFace[72][1] = 3;

	InterFace[73][0] = 0;	InterFace[73][1] = 1;	InterFace[73][2] = 3;

}


/* * * * * * * * * * * * * * * * * * * * * * * * *
*
*  ƣ
*
*  ܣ
*
*  ޸ʱ䣺1999.3.22
*
* * * * * * * * * * * * * * * * * * * * * * * * */
CHWRECTView::~CHWRECTView()
{
}

BOOL CHWRECTView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

//һЩ豸
int CHWRECTView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	//ɫĺڱ
	whitePen = new CPen(PS_SOLID,1,WHITE);
	
	//ɫĺڱ
	blackPen = new CPen(PS_SOLID,1,BLACK);

	//ˢ
	grayBrush = new CBrush(RGB(0,255,255));
	blueBrush = new CBrush(BLUE);
	blackBrush = new CBrush(BLACK);

	//һεķʽ
	m_inextStatus = Random(7);
	if (m_inextStatus==0) m_inextStatus++;
	
	return 0;
}

/* * * * * * * * * * * * * * * * * * * * * * * * *
*
*  ƣOnDraw
*
*  ܣелĻ
*
*  ޸ʱ䣺1999.3.22
*
* * * * * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::OnDraw(CDC* pDC)
{
	CHWRECTDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	int i,j;
	
	//CBrush *oldBrush = 
	pDC -> SelectObject(blackBrush);
	CRect rect;
	GetClientRect(&rect);
	pDC -> Rectangle(rect);

	pDC -> SelectObject(grayBrush);
	pDC -> Rectangle(m_iStartY ,m_iStartX, m_iStartY + 301, m_iStartX + 360);
	
	pDC -> SelectObject(blueBrush);

	//CPen *oldPen = 
	pDC->SelectObject(blackPen);
	
	//
	if (m_bDrawGrid)
	{
		//
		for (i=0;i<m_iRow;i++)
		{
			pDC->MoveTo(m_iStartY, m_iStartX + i*m_iLarge);
			pDC->LineTo(m_iStartY+300, m_iStartX +i*m_iLarge);
		}	
		
		//
		for (i=0;i<m_iCol;i++)
		{
			pDC->MoveTo(m_iStartY+i*m_iLarge, m_iStartX);
			pDC->LineTo(m_iStartY+i*m_iLarge, m_iStartX+360);
		}
	}

	//
	for (i=0;i<m_iRow;i++)
		for (j=0;j<m_iCol;j++)
		{
			if (GameStatus[i][j]==1)
			{
				//ķȹ涨ĴС΢Сһ
				//С߿
				pDC -> SelectObject(blackPen);
				pDC -> MoveTo(m_iStartY+j*m_iLarge +1, m_iStartX+i*m_iLarge +1);
				pDC -> LineTo(m_iStartY+j*m_iLarge +1, m_iStartX+(i+1)*m_iLarge -1);
				pDC -> MoveTo(m_iStartY+j*m_iLarge +1,	m_iStartX+(i+1)*m_iLarge -1);
				pDC -> LineTo(m_iStartY+(j+1)*m_iLarge -1, m_iStartX+(i+1)*m_iLarge -1);

				//С߿
				pDC -> SelectObject(whitePen);
				pDC -> MoveTo(m_iStartY+j*m_iLarge +1, m_iStartX+i*m_iLarge +1);
				pDC -> LineTo(m_iStartY+(j+1)*m_iLarge -1,m_iStartX+i*m_iLarge +1);
				pDC -> MoveTo(m_iStartY+(j+1)*m_iLarge -1,m_iStartX+i*m_iLarge +1);
				pDC -> LineTo(m_iStartY+(j+1)*m_iLarge -1,m_iStartX+(i+1)*m_iLarge -1);

				//ÿɫı 
				pDC -> Rectangle(m_iStartY+j*m_iLarge +2,m_iStartX+i*m_iLarge +2,m_iStartY+(j+1)*m_iLarge -2,m_iStartX+(i+1)*m_iLarge -2);

			}
		}

	//ʾϷϷĺ
	if (!m_bGameEnd)
	{
		pDC -> SetBkColor(BLACK);
		pDC -> SetTextColor(WHITE);
		pDC -> TextOut(m_iStartY+320, m_iStartX+220, "ϷС");
		pDC -> TextOut(m_iStartY+320, m_iStartX+240,m_strArea);

		pDC -> TextOut(m_iStartY+320, m_iStartX+280, "Ϸ");
		pDC -> TextOut(m_iStartY+320, m_iStartX+300,m_strLevel);
	}
		
		
	//ʾܷ
	if (!m_bGameEnd)
	{
		CString lsStr;	
		lsStr.Format("ܷΪ%d ",m_iPerformance);
		pDC -> SetBkColor(BLACK);
		pDC -> SetTextColor(WHITE);
		pDC -> TextOut(m_iStartY+320, m_iStartX+180,lsStr);
	}

	//һνҪֵķ飬ʾû
	if (!m_bGameEnd)
	{
		pDC -> SetBkColor(BLACK);
		pDC -> SetTextColor(WHITE);
		pDC -> TextOut(m_iStartY+320, m_iStartX,"һ飺");
		
		for (UINT k=0;k<4;k++)
		{
			i = NextStatus[k][0];
		    j = NextStatus[k][1];

			//ķȹ涨ĴС΢Сһ
			//С߿
			pDC -> SelectObject(blackPen);
			pDC -> MoveTo(m_iStartY+j*30 +1+320, m_iStartX+i*30 +1+30);
			pDC -> LineTo(m_iStartY+j*30 +1+320, m_iStartX+(i+1)*30 -1+30);
			pDC -> MoveTo(m_iStartY+j*30 +1+320,	m_iStartX+(i+1)*30 -1+30);
			pDC -> LineTo(m_iStartY+(j+1)*30 -1+320, m_iStartX+(i+1)*30 -1+30);

			//С߿
			pDC -> SelectObject(whitePen);
			pDC -> MoveTo(m_iStartY+j*30 +1+320,      m_iStartX+i*30 +1+30);
			pDC -> LineTo(m_iStartY+(j+1)*30 -1+320,  m_iStartX+i*30 +1+30);
			pDC -> MoveTo(m_iStartY+(j+1)*30 -1+320,  m_iStartX+i*30 +1+30);
			pDC -> LineTo(m_iStartY+(j+1)*30 -1+320,  m_iStartX+(i+1)*30 -1+30);

			//ÿɫı 
			pDC -> Rectangle(m_iStartY+j*30 +2+320,m_iStartX+i*30 +2+30,
							 m_iStartY+(j+1)*30 -2+320,m_iStartX+(i+1)*30 -2+30);
		}
	}

//	pDC -> SelectObject(oldPen);
//	pDC -> SelectObject(oldBrush);
}

/////////////////////////////////////////////////////////////////////////////
// CHWRECTView diagnostics

#ifdef _DEBUG
void CHWRECTView::AssertValid() const
{
	CView::AssertValid();
}

void CHWRECTView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CHWRECTDoc* CHWRECTView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHWRECTDoc)));
	return (CHWRECTDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHWRECTView message handlers



/* * * * * * * * * * * * * * * * * * * * * * * * *
*
*  ƣOnTimer
*
*  ܣе
*
*  ޸ʱ䣺1999.3.22
*
* * * * * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::OnTimer(UINT nIDEvent) 
{
	//ԭķѵ׻Ϸտʼһµķ
	int i,j,k;
	if (m_isBottom)
	{
		m_icurrentStatus = m_inextStatus;
		m_inextStatus = Random(7);  //õһεķʽ
		if (m_inextStatus==0) m_inextStatus++;
		
		m_currentRect = m_icurrentStatus;   //ǰµķ״
		RectStatusToActiveStatus( m_icurrentStatus );
		ActiveStatusToGameStatus();
		m_isBottom = FALSE;
		ActiveIsBottom();

		InvalidateCurrent();

		//Ļұʾһνķģ
		RectStatusToNextStatus( m_inextStatus );
		CRect rect(m_iStartY+320, m_iStartX, m_iStartY+440, m_iStartX+160);
		InvalidateRect(&rect);

    	//жϷǷѽ: ˵ףҵ1С
		if (m_isBottom)
			for (i=0;i<m_iCol;i++)
				if (GameStatus[0][i])
				{
					KillTimer(1);
					AfxMessageBox("Ϸѽ");
					for (j=0;j<m_iRow;j++)
						for (k=0;k<m_iCol;k++)
							GameStatus[j][k]=0;
					Invalidate();
					m_bGameEnd = TRUE;
					break;
				}


	}
	else  //ǰ½
	{
		RectDown();
	}

	
	CView::OnTimer(nIDEvent);
}


/* * * * * * * * * * * * * * * * * * * * * *
* ڲһֵֵָ(Random)
*
* MaxNumber : 
* 
* ֵ: 
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
int CHWRECTView::Random(int MaxNumber)
{
	int currentClock = (int)clock();
	srand(currentClock);
	return (rand() % MaxNumber);
}


/* * * * * * * * * * * * * * * * * * * * * *
* ڲǰ̬еݷӳ
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::ActiveStatusToGameStatus()
{
	int x1,x2,x3,x4,y1,y2,y3,y4;
	x1 = ActiveStatus[0][0];
	x2 = ActiveStatus[1][0];
	x3 = ActiveStatus[2][0];
	x4 = ActiveStatus[3][0];
	y1 = ActiveStatus[0][1];
	y2 = ActiveStatus[1][1];
	y3 = ActiveStatus[2][1];
	y4 = ActiveStatus[3][1];
	GameStatus[x1][y1]=1;
	GameStatus[x2][y2]=1;
	GameStatus[x3][y3]=1;
	GameStatus[x4][y4]=1;
}

/* * * * * * * * * * * * * * * * * * * * * *
* ڲʼʱݷʽǰֵ̬
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::RectStatusToActiveStatus(int m_which)
{
	switch(m_which)
	{
	case 1:
		ActiveStatus[0][0] = 0;	ActiveStatus[0][1] = 5;	ActiveStatus[1][0] = 1;	ActiveStatus[1][1] = 5;
		ActiveStatus[2][0] = 2;	ActiveStatus[2][1] = 5;	ActiveStatus[3][0] = 3;	ActiveStatus[3][1] = 5;
		break;
	case 2:
		ActiveStatus[0][0] = 0;	ActiveStatus[0][1] = 5;	ActiveStatus[1][0] = 1;	ActiveStatus[1][1] = 5;
		ActiveStatus[2][0] = 0;	ActiveStatus[2][1] = 6;	ActiveStatus[3][0] = 1;	ActiveStatus[3][1] = 6;
		break;
	case 3:
		ActiveStatus[0][0] = 1;	ActiveStatus[0][1] = 4;	ActiveStatus[1][0] = 0;	ActiveStatus[1][1] = 5;
		ActiveStatus[2][0] = 1;	ActiveStatus[2][1] = 5;	ActiveStatus[3][0] = 1;	ActiveStatus[3][1] = 6;
		break;
	case 4:
		ActiveStatus[0][0] = 0;	ActiveStatus[0][1] = 5;	ActiveStatus[1][0] = 1;	ActiveStatus[1][1] = 5;
		ActiveStatus[2][0] = 1;	ActiveStatus[2][1] = 6;	ActiveStatus[3][0] = 2;	ActiveStatus[3][1] = 6;
		break;
	case 5:
		ActiveStatus[0][0] = 1;	ActiveStatus[0][1] = 5;	ActiveStatus[1][0] = 2;	ActiveStatus[1][1] = 5;
		ActiveStatus[2][0] = 0;	ActiveStatus[2][1] = 6;	ActiveStatus[3][0] = 1;	ActiveStatus[3][1] = 6;
		break;
	case 6:
		ActiveStatus[0][0] = 0;	ActiveStatus[0][1] = 5;	ActiveStatus[1][0] = 0;	ActiveStatus[1][1] = 6;
		ActiveStatus[2][0] = 1;	ActiveStatus[2][1] = 6;	ActiveStatus[3][0] = 2;	ActiveStatus[3][1] = 6;
		break;
	case 7:
		ActiveStatus[0][0] = 0;	ActiveStatus[0][1] = 5;	ActiveStatus[1][0] = 1;	ActiveStatus[1][1] = 5;
		ActiveStatus[2][0] = 2;	ActiveStatus[2][1] = 5;	ActiveStatus[3][0] = 0;	ActiveStatus[3][1] = 6;
		break;
	}
}

/* * * * * * * * * * * * * * * * * * * * * *
* ڲʼʱݷʽһνҪĶֵ̬
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::RectStatusToNextStatus(int m_which)
{
	switch(m_which)
	{
	case 1:
		NextStatus[0][0] = 0;	NextStatus[0][1] = 1;	NextStatus[1][0] = 1;	NextStatus[1][1] = 1;
		NextStatus[2][0] = 2;	NextStatus[2][1] = 1;	NextStatus[3][0] = 3;	NextStatus[3][1] = 1;
		break;
	case 2:
		NextStatus[0][0] = 0;	NextStatus[0][1] = 1;	NextStatus[1][0] = 1;	NextStatus[1][1] = 1;
		NextStatus[2][0] = 0;	NextStatus[2][1] = 2;	NextStatus[3][0] = 1;	NextStatus[3][1] = 2;
		break;
	case 3:
		NextStatus[0][0] = 1;	NextStatus[0][1] = 0;	NextStatus[1][0] = 0;	NextStatus[1][1] = 1;
		NextStatus[2][0] = 1;	NextStatus[2][1] = 1;	NextStatus[3][0] = 1;	NextStatus[3][1] = 2;
		break;
	case 4:
		NextStatus[0][0] = 0;	NextStatus[0][1] = 1;	NextStatus[1][0] = 1;	NextStatus[1][1] = 1;
		NextStatus[2][0] = 1;	NextStatus[2][1] = 2;	NextStatus[3][0] = 2;	NextStatus[3][1] = 2;
		break;
	case 5:
		NextStatus[0][0] = 1;	NextStatus[0][1] = 1;	NextStatus[1][0] = 2;	NextStatus[1][1] = 1;
		NextStatus[2][0] = 0;	NextStatus[2][1] = 2;	NextStatus[3][0] = 1;	NextStatus[3][1] = 2;
		break;
	case 6:
		NextStatus[0][0] = 0;	NextStatus[0][1] = 1;	NextStatus[1][0] = 0;	NextStatus[1][1] = 2;
		NextStatus[2][0] = 1;	NextStatus[2][1] = 2;	NextStatus[3][0] = 2;	NextStatus[3][1] = 2;
		break;
	case 7:
		NextStatus[0][0] = 0;	NextStatus[0][1] = 1;	NextStatus[1][0] = 1;	NextStatus[1][1] = 1;
		NextStatus[2][0] = 2;	NextStatus[2][1] = 1;	NextStatus[3][0] = 0;	NextStatus[3][1] = 2;
		break;
	}
}

/* * * * * * * * * * * * * * * * * * * * * *
* ڲǰ½
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::RectDown()
{
	ActiveIsBottom();
	if (!m_isBottom)
	{
		//ǰķ
		int x1,x2,x3,x4,y1,y2,y3,y4;
		x1 = ActiveStatus[0][0];
		x2 = ActiveStatus[1][0];
		x3 = ActiveStatus[2][0];
		x4 = ActiveStatus[3][0];
		y1 = ActiveStatus[0][1];
		y2 = ActiveStatus[1][1];
		y3 = ActiveStatus[2][1];
		y4 = ActiveStatus[3][1];
		GameStatus[x1][y1]=0;
		GameStatus[x2][y2]=0;
		GameStatus[x3][y3]=0;
		GameStatus[x4][y4]=0;
		InvalidateCurrent();

		//
		ActiveStatus[0][0] += 1;
		ActiveStatus[1][0] += 1;
		ActiveStatus[2][0] += 1;
		ActiveStatus[3][0] += 1;
		GameStatus[x1+1][y1]=1;
		GameStatus[x2+1][y2]=1;
		GameStatus[x3+1][y3]=1;
		GameStatus[x4+1][y4]=1;

		InvalidateCurrent();
	}
}

	
/* * * * * * * * * * * * * * * * * * * * * *
* ڲǰ½٣ƣ
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::RectArrow(int m_Type)
{
	//ǰķ
	int x1,x2,x3,x4,y1,y2,y3,y4;
	x1 = ActiveStatus[0][0];
	x2 = ActiveStatus[1][0];
	x3 = ActiveStatus[2][0];
	x4 = ActiveStatus[3][0];
	y1 = ActiveStatus[0][1];
	y2 = ActiveStatus[1][1];
	y3 = ActiveStatus[2][1];
	y4 = ActiveStatus[3][1];

	//ѵƶ
	switch(m_Type)
	{
	case LEFT:
		if ( (ActiveStatus[0][1]>0) && LeftIsLimit() && !m_isBottom)
		{
			//ԭķ
			GameStatus[x1][y1]=0;
			GameStatus[x2][y2]=0;
			GameStatus[x3][y3]=0;
			GameStatus[x4][y4]=0;

			InvalidateCurrent();

			ActiveStatus[0][1] -= 1;
			ActiveStatus[1][1] -= 1;
			ActiveStatus[2][1] -= 1;
			ActiveStatus[3][1] -= 1;
			GameStatus[x1][y1-1]=1;
			GameStatus[x2][y2-1]=1;
			GameStatus[x3][y3-1]=1;
			GameStatus[x4][y4-1]=1;

			InvalidateCurrent();
		}
		break;
	case RIGHT:
		if ( (ActiveStatus[3][1]< m_iCol-1) && RightIsLimit() && !m_isBottom)
		{
			//ԭķ
			GameStatus[x1][y1]=0;
			GameStatus[x2][y2]=0;
			GameStatus[x3][y3]=0;
			GameStatus[x4][y4]=0;

			InvalidateCurrent();

			ActiveStatus[0][1] += 1;
			ActiveStatus[1][1] += 1;
			ActiveStatus[2][1] += 1;
			ActiveStatus[3][1] += 1;
			GameStatus[x1][y1+1]=1;
			GameStatus[x2][y2+1]=1;
			GameStatus[x3][y3+1]=1;
			GameStatus[x4][y4+1]=1;
			
			InvalidateCurrent();
		}
		break;
	case DOWN:
		//˳½ÿһжǷѵ
		RectDown();
		break;
	}

}

/* * * * * * * * * * * * * * * * * * * * * *
* ڲжϵǰǷѵ
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::ActiveIsBottom()
{
	//ָ1ѵײ2ķ
	int x1,x2,x3,x4;
	int x,xx,yy,i;

	x1 = ActiveStatus[0][0];
	x2 = ActiveStatus[1][0];
	x3 = ActiveStatus[2][0];
	x4 = ActiveStatus[3][0];

    //ѵ
	//ķ
	//һΪĸС飬ֻСķ㵽ףС£
	//治бС
	//㷨ΪyȵһСеĸС, ҳ֮ΪӴ

	if (x1>=m_iRow-1 || x2>=m_iRow-1 || x3>=m_iRow-1 || x4>=m_iRow-1)
		m_isBottom = TRUE;
	else
	{
		for (i=0;i<4;i++)
		{
			if (InterFace[m_currentRect][i] > -1)
			{
				x=InterFace[m_currentRect][i];
				xx=ActiveStatus[x][0]+1;
				yy=ActiveStatus[x][1];
				if (GameStatus[xx][yy]==1)
					m_isBottom = TRUE;
			}
		}
	}

	BOOL m_bIsSucced;
	int k,j;
	int m_iMuch=0; //

	//ƷֹһһУ100֣һУ400֣У900
	//xУΪx*(x*100)

	if (m_isBottom)
	{
		//жǷѵ÷
		for (i=0;i<m_iRow;i++)
		{
			m_bIsSucced = TRUE;
			for (j=0;j<m_iCol;j++)
				if (GameStatus[i][j]==0)
					m_bIsSucced = FALSE;
			
			//÷֣
			if (m_bIsSucced)
			{
				for (k=i;k>0;k--)
					for (j=0;j<m_iCol;j++)
						GameStatus[k][j] = GameStatus[k-1][j];
				//1
				for (j=0;j<m_iCol;j++)
					GameStatus[0][j]=0;

				m_iMuch += 1;
			}
		}
		
		if (m_iMuch>0)
		{
			m_iPerformance += m_iMuch * m_iMuch * 100;
			//ˢϷ
			CRect rect1(m_iStartY, m_iStartX, m_iStartY+300, m_iStartX+360);
			InvalidateRect(&rect1);

			//ˢ·
			CRect rect2(m_iStartY+320, m_iStartX+180, m_iStartY+440, m_iStartX+200);
			InvalidateRect(&rect2);
		}

	}

}

/* * * * * * * * * * * * * * * * * * * * * * * * *
*
*  ƣOnKeyDown
*
*  ܣû룬ƣټ
*
*  ޸ʱ䣺1999.3.22
*
* * * * * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{

	switch(nChar)
	{
	case 'a':
	case 'A':
	case VK_LEFT:
		RectArrow(LEFT);
		break;
	case 'd':
	case 'D':
	case VK_RIGHT:
		RectArrow(RIGHT);
		break;
	case 's':
	case 'S':
	case VK_UP:
		RectChange();
		break;
	case 'x':
	case 'X':
	case VK_DOWN:
		RectArrow(DOWN);
		break;
	}

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}


/* * * * * * * * * * * * * * * * * * * * * *
* ڲǷ񻹿
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
BOOL CHWRECTView::LeftIsLimit()
{

	int x1,x2,x3,x4,y1,y2,y3,y4;
	x1 = ActiveStatus[0][0];
	x2 = ActiveStatus[1][0];
	x3 = ActiveStatus[2][0];
	x4 = ActiveStatus[3][0];
	y1 = ActiveStatus[0][1];
	y2 = ActiveStatus[1][1];
	y3 = ActiveStatus[2][1];
	y4 = ActiveStatus[3][1];
	
	switch(m_currentRect)
	{
	case 1:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x3][y3-1] || GameStatus[x4][y4-1])
			return FALSE;
		break;
	case 11:
		if (GameStatus[x1][y1-1])
			return FALSE;
		break;
	case 2:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1])
			return FALSE;
		break;
	case 3:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1])
			return FALSE;
		break;
	case 31:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 32:
		if (GameStatus[x1][y1-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 33:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x4][y4-1])
			return FALSE;
		break;
	case 4:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x4][y4-1])
			return FALSE;
		break;
	case 41:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1])
			return FALSE;
		break;
	case 5:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 51:
		if (GameStatus[x1][y1-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 6:
		if (GameStatus[x1][y1-1] || GameStatus[x3][y3-1] || GameStatus[x4][y4-1])
			return FALSE;
		break;
	case 61:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1])
			return FALSE;
		break;
	case 62:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 63:
		if (GameStatus[x1][y1-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 7:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 71:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1])
			return FALSE;
		break;
	case 72:
		if (GameStatus[x1][y1-1] || GameStatus[x2][y2-1] || GameStatus[x3][y3-1])
			return FALSE;
		break;
	case 73:
		if (GameStatus[x1][y1-1] || GameStatus[x4][y4-1])
			return FALSE;
		break;
	}

	return TRUE;
			
}

/* * * * * * * * * * * * * * * * * * * * * *
* ڲǷ񻹿
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
BOOL CHWRECTView::RightIsLimit()
{

	int x1,x2,x3,x4,y1,y2,y3,y4;
	x1 = ActiveStatus[0][0];
	x2 = ActiveStatus[1][0];
	x3 = ActiveStatus[2][0];
	x4 = ActiveStatus[3][0];
	y1 = ActiveStatus[0][1];
	y2 = ActiveStatus[1][1];
	y3 = ActiveStatus[2][1];
	y4 = ActiveStatus[3][1];
	
	switch(m_currentRect)
	{
	case 1:
		if (GameStatus[x1][y1+1] || GameStatus[x2][y2+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 11:
		if (GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 2:
		if (GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 3:
		if (GameStatus[x2][y2+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 31:
		if (GameStatus[x1][y1+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 32:
		if (GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 33:
		if (GameStatus[x2][y2+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 4:
		if (GameStatus[x1][y1+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 41:
		if (GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 5:
		if (GameStatus[x2][y2+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 51:
		if (GameStatus[x2][y2+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 6:
		if (GameStatus[x2][y2+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 61:
		if (GameStatus[x2][y2+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 62:
		if (GameStatus[x1][y1+1] || GameStatus[x2][y2+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 63:
		if (GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 7:
		if (GameStatus[x2][y2+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 71:
		if (GameStatus[x1][y1+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 72:
		if (GameStatus[x2][y2+1] || GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	case 73:
		if (GameStatus[x3][y3+1] || GameStatus[x4][y4+1])
			return FALSE;
		break;
	}

	return TRUE;
			

}


/* * * * * * * * * * * * * * * * * * * * * *
* ڲı
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::RectChange()
{
	//ԤȱΣȻжϱκķǷпռ䣬㹻ռ䣬ʵʱΣ򲻱
	int xx1,xx2,xx3,xx4,yy1,yy2,yy3,yy4;
	int m_lscurrentRect;
	
	CString lsStr;
	
	int x1,x2,x3,x4,y1,y2,y3,y4;
	x1 = ActiveStatus[0][0];
	x2 = ActiveStatus[1][0];
	x3 = ActiveStatus[2][0];
	x4 = ActiveStatus[3][0];
	y1 = ActiveStatus[0][1];
	y2 = ActiveStatus[1][1];
	y3 = ActiveStatus[2][1];
	y4 = ActiveStatus[3][1];

	//κλеĴ˳ѭңͬһϺ
	xx1=x1; xx2=x2; xx3=x3; xx4=x4; yy1=y1; yy2=y2; yy3=y3; yy4=y4;
	switch(m_currentRect)
	{
	case 1:
		xx1=x1+1; yy1=y1-1; xx3=x3-1; yy3=y3+1; xx4=x4-2; yy4=y4+2;
		m_lscurrentRect = 11;
		break;
	case 11:
		xx1=x1-1; yy1=y1+1; xx3=x3+1; yy3=y3-1; xx4=x4+2; yy4=y4-2;
		m_lscurrentRect = 1;
		break;
	case 2:
		m_lscurrentRect=2; 
		break;
	case 3:
		xx1=x1-2; yy1=y1+1; xx4=x4-1; yy4=y4;
		m_lscurrentRect = 31;
		break;
	case 31:
		xx1=x1+1; yy1=y1-1; 
		m_lscurrentRect = 32;
		break;
	case 32:
		xx1=x1+1; yy1=y1; xx4=x4+2; yy4=y4-1;
		m_lscurrentRect=33;
		break;
	case 33:
		xx4=x4-1; yy4=y4+1;
		m_lscurrentRect=3;
		break;
	case 4:
		xx1=x1+2; yy1=y1-1; xx3=x3+1; yy3=y3-1; xx4=x4-1;
		m_lscurrentRect = 41;
		break;
	case 41:
		xx1=x1-2; yy1=y1+1; xx3=x3-1; yy3=y3+1; xx4=x4+1;
		m_lscurrentRect = 4;
		break;
	case 5:
		xx1=x1-1; xx2=x2-2; yy2=y2+1; xx3=x3+1; yy4=y4+1;
		m_lscurrentRect = 51;
		break;
	case 51:
		xx1=x1+1; xx2=x2+2; yy2=y2-1; xx3=x3-1; yy4=y4-1;
		m_lscurrentRect = 5;
		break;
	case 6:
		xx2=x1+1; yy2=y2-1; xx3=x3-1; xx4=x4-2; yy4 = yy4+1;
		m_lscurrentRect = 61;
		break;
	case 61:
		xx3=x3+2; yy3=y3-1; xx4=x4+2; yy4=y4-1;
		m_lscurrentRect = 62;
		break;
	case 62:
		xx1=x1+1; yy1=y1-1; xx3=x3-2; yy3=y3+1; xx4=x4-1;
		m_lscurrentRect = 63;
		break;
	case 63:
		xx1=x1-2; yy1=y1+1; xx2=x2-2; yy2=y2+1;
		m_lscurrentRect = 6;
		break;
	case 7:
		xx3=x3-1; yy3=y3+1; xx4=x4+1; yy4=y4+1;
		m_lscurrentRect = 71;
		break;
	case 71:
		xx1=x1+2; xx2=x2-1; yy2=y2+1; xx4=x4+1; yy4=y4-1;
		m_lscurrentRect = 72;
		break;
	case 72:
		xx1=x1-2; xx3=x3-1; yy3=y3+1; xx4=x4-1; yy4=y4+1;
		m_lscurrentRect = 73;
		break;
	case 73:
		xx2=x2+1; yy2=y2-1; xx3=x3+2; yy3=y3-2; xx4=x4-1; yy4=y4-1;
		m_lscurrentRect = 7;
		break;
	}

	//κڵ飬ʾ㹻ռ䣬Ա
	//ҲܳԽ߽
	GameStatus[x1][y1] = 0;
	GameStatus[x2][y2] = 0;
	GameStatus[x3][y3] = 0;
	GameStatus[x4][y4] = 0;
	if (GameStatus[xx1][yy1]==0 && GameStatus[xx2][yy2]==0 && GameStatus[xx3][yy3]==0 && GameStatus[xx4][yy4]==0 
		&& yy1>=0 && yy4<=m_iCol-1 
		&& !(xx1<0 || xx2<0 || xx3<0 || xx4<0) 
		&& !(xx1>m_iRow-1 || xx2>m_iRow-1 || xx3>m_iRow-1 || xx4>m_iRow-1) )
	{
		InvalidateCurrent();

		ActiveStatus[0][0]=xx1;
		ActiveStatus[1][0]=xx2;
		ActiveStatus[2][0]=xx3;
		ActiveStatus[3][0]=xx4;
		ActiveStatus[0][1]=yy1;
		ActiveStatus[1][1]=yy2;
		ActiveStatus[2][1]=yy3;
		ActiveStatus[3][1]=yy4;

		GameStatus[xx1][yy1] = 1;
		GameStatus[xx2][yy2] = 1;
		GameStatus[xx3][yy3] = 1;
		GameStatus[xx4][yy4] = 1;

		InvalidateCurrent();

		//ı״
		m_currentRect = m_lscurrentRect;
	}
	else
	{
		GameStatus[x1][y1] = 1;
		GameStatus[x2][y2] = 1;
		GameStatus[x3][y3] = 1;
		GameStatus[x4][y4] = 1;
	}

	//жǷѵ
	ActiveIsBottom();
}


/* * * * * * * * * * * * * * * * * * * * * *
* ڲϷʼ
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::OnGameStart() 
{
	if (!m_bGamePaush)  //Ϸͣ״̬Щʼ
	{
		m_bGameEnd = FALSE;
		//ֵܷ, ʾּܷǷ
		m_iPerformance = 0;
	
		//ʾǰϷĺ
		CurrentAreaAndLevel();
		
		CRect rect(m_iStartY, m_iStartX, m_iStartY+440, m_iStartX+370);
		InvalidateRect(&rect);
	}

	m_bGamePaush = FALSE;
	SetTimer(1,1500-250*m_iLevel,NULL);
}


//Ϸͣ
void CHWRECTView::OnGamePaush() 
{
	m_bGamePaush = TRUE;

	KillTimer(1);
}

/* * * * * * * * * * * * * * * * * * * * * *
* ڲϷ
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::OnGameEnd() 
{
	m_bGameEnd = TRUE;

	int i,j;
	for (i=0;i<m_iRow;i++)
		for (j=0;j<m_iCol;j++)
			GameStatus[i][j]=0;

	CRect rect(m_iStartY, m_iStartX, m_iStartY+440, m_iStartX+370);
	InvalidateRect(&rect);

	m_bGamePaush = FALSE;  //Ϸͣ״̬

	KillTimer(1);	

}

/* * * * * * * * * * * * * * * * * * * * * *
* ڲˢµǰ
*
* ֻˢҪˢµĸС򣬷ֹĻ
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::InvalidateCurrent()
{
	int i;
	
	for (i=0;i<4;i++)
	{
			CRect rect(m_iStartX+ActiveStatus[i][1]*m_iLarge,  m_iStartY+ActiveStatus[i][0]*m_iLarge,
					   m_iStartX+(ActiveStatus[i][1]+1)*m_iLarge+5,  m_iStartY+(ActiveStatus[i][0]+1)*m_iLarge);
			InvalidateRect(&rect);
	}
}


/* * * * * * * * * * * * * * * * * * * * * *
* ڲϷ
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
void CHWRECTView::OnGameOption() 
{
	//˳ С룺0-3ֱΪ12X1018X1524X20m_iLargeX25
	//0-5ֱΪ150012001000800600400
	//֣TRUE  FALSE
	int m_lsArea;
	switch(m_iRow)
	{
	case 12:
		m_lsArea = 0;
		break;
	case 18:
		m_lsArea = 1;
		break;
	case 24:
		m_lsArea = 2;
		break;
	case 30:
		m_lsArea = 3;
		break;
	}

	COptionDlg dlg(m_lsArea,m_iLevel,m_bMusic,m_bDrawGrid);
	
	if (dlg.DoModal()==IDOK)
	{
		//ȷĴС
		switch(dlg.m_iArea)
		{
		case 0:
			m_iRow = 12;
			m_iCol = 10;
			m_iLarge = 30;
			break;
		case 1:
			m_iRow = 18;
			m_iCol = 15;
			m_iLarge = 20;
			break;
		case 2:
			m_iRow = 24;
			m_iCol = 20;
			m_iLarge = 15;
			break;
		case 3:
			m_iRow = 30;
			m_iCol = 25;
			m_iLarge = 12;
			break;
		}

		//ȷ
		m_iLevel = dlg.m_iLevel;

		//ȷǷ񱳾
		m_bDrawGrid = dlg.m_bDrawGrid;

        //Ƿ								  
		m_bMusic = dlg.m_bMusic;
		if (m_bMusic)
			PlayMid();
		else
			StopMid();

		Invalidate();
	}	
}


//ɵǰС뼶Ӧĺ
void CHWRECTView::CurrentAreaAndLevel()
{
	switch(m_iRow)
	{
	case 12:
		m_strArea = "1210"; break;
	case 18:
		m_strArea = "1815"; break;
	case 24:
		m_strArea = "2420"; break;
	case 30:
		m_strArea = "3025"; break;
	}

	switch(m_iLevel)
	{
	case 0:
		m_strLevel = "һ: ţ"; break;
	case 1:
		m_strLevel = "ڶ: Ѽ"; break;
	case 2:
		m_strLevel = ": ۼ"; break;
	case 3:
		m_strLevel = "ļ: Թ"; break;
	case 4:
		m_strLevel = "弶: Ʊ"; break;
	case 5:
		m_strLevel = ": ӥ"; break;
	}
}


/* * * * * * * * * * * * * * * * * * * * * *
* ڲΪ˵뿪
*
* ޸ڣ1999.1.22
* * * * * * * * * * * * * * * * * * * * * */
//Ϸʼ[ʼϷ]ť
void CHWRECTView::OnUpdateGameStart(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd || m_bGamePaush)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

//Ϸʼ[Ϸ]ť
void CHWRECTView::OnUpdateGameOption(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

//Ϸʼ[Ϸͣ]ť
void CHWRECTView::OnUpdateGamePaush(CCmdUI* pCmdUI) 
{
	if (!m_bGameEnd)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

//Ϸʼ[Ϸ]ť
void CHWRECTView::OnUpdateGameEnd(CCmdUI* pCmdUI) 
{
	if (!m_bGameEnd)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
	
}

//Ϸʼ[˳ϵͳ]ť
void CHWRECTView::OnUpdateGameExit(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

//Ϸʼ[]ť
void CHWRECTView::OnUpdateHelpAbout(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

//Ϸʼ[]ť
void CHWRECTView::OnUpdateHelpHelp(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(FALSE);	
}


void CHWRECTView::OnHelpHelp() 
{

}


//ò˵С
void CHWRECTView::OnUpdateOptionArea1(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iRow==12)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);	
}
void CHWRECTView::OnUpdateOptionArea2(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iRow==18)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);	
}
void CHWRECTView::OnUpdateOptionArea3(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iRow==24)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);	
}
void CHWRECTView::OnUpdateOptionArea4(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iRow==30)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);	
}


//ò˵С
void CHWRECTView::OnOptionArea1() 
{
	m_iRow = 12;
	m_iCol = 10;
	m_iLarge = 30;
	Invalidate();
}

void CHWRECTView::OnOptionArea2() 
{
	m_iRow = 18;
	m_iCol = 15;
	m_iLarge = 20;
	Invalidate();
}

void CHWRECTView::OnOptionArea3() 
{
	m_iRow = 24;
	m_iCol = 20;
	m_iLarge = 15;
	Invalidate();
}

void CHWRECTView::OnOptionArea4() 
{
	m_iRow = 30;
	m_iCol = 25;
	m_iLarge = 12;
	Invalidate();
}

// ò˵Ϸ 
void CHWRECTView::OnUpdateOptionLevel1(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iLevel == 0)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}

void CHWRECTView::OnUpdateOptionLevel2(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iLevel == 1)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}

void CHWRECTView::OnUpdateOptionLevel3(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iLevel == 2)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}

void CHWRECTView::OnUpdateOptionLevel4(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iLevel == 3)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}

void CHWRECTView::OnUpdateOptionLevel5(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iLevel == 4)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}

void CHWRECTView::OnUpdateOptionLevel6(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd) 
		pCmdUI -> Enable(TRUE);
	else 
		pCmdUI -> Enable(FALSE);

	if (m_iLevel == 5)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}


//ò˵Ϸ
void CHWRECTView::OnOptionLevel1() 
{
	m_iLevel = 0;
}

void CHWRECTView::OnOptionLevel2() 
{
	m_iLevel = 1;
}

void CHWRECTView::OnOptionLevel3() 
{
	m_iLevel = 2;
}

void CHWRECTView::OnOptionLevel4() 
{
	m_iLevel = 3;
}

void CHWRECTView::OnOptionLevel5() 
{
	m_iLevel = 4;
}

void CHWRECTView::OnOptionLevel6() 
{
	m_iLevel = 5;
}


//ò˵Ƿ
void CHWRECTView::OnUpdateOptionGrid(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd)
		pCmdUI -> Enable(TRUE);
	else
		pCmdUI -> Enable(FALSE);

	if (m_bDrawGrid)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}

void CHWRECTView::OnOptionGrid() 
{
	if (m_bDrawGrid)
		m_bDrawGrid = FALSE;
	else
		m_bDrawGrid = TRUE;

	Invalidate();
}


//ű, д
void CHWRECTView::PlayMid()
{
	HWND hWnd;
	hWnd = GetSafeHwnd();

	char inBuf[300],outBuf[60],fileName[255];
	MCIERROR mciError;

	strcpy(fileName,"hwrect.mid"); 
	wsprintf( inBuf,"open %s type sequencer alias myseq",fileName);
	mciError = mciSendString( inBuf, outBuf, sizeof(outBuf), NULL);
	if (mciError == 0)
	{
		mciError = mciSendString("play myseq notify",NULL,0, hWnd);
		if (mciError != 0)
			mciSendString("close myseq",NULL,0,NULL);
	}
}

//ֹű
void CHWRECTView::StopMid()
{
	mciSendString("close myseq",NULL,0,NULL);
}

//ò˵Ƿ
void CHWRECTView::OnUpdateOptionMusic(CCmdUI* pCmdUI) 
{
	if (m_bGameEnd)
		pCmdUI -> Enable(TRUE);
	else
		pCmdUI -> Enable(FALSE);

	if (m_bMusic)
		pCmdUI -> SetCheck(TRUE);
	else
		pCmdUI -> SetCheck(FALSE);
}

void CHWRECTView::OnOptionMusic() 
{
	if (m_bMusic)
	{
		m_bMusic = FALSE;
		StopMid();
	}
	else
	{
		m_bMusic = TRUE;
		PlayMid();
	}
	
}


